*!*********************************************************************
*!
*      Function: EREPT(string)
*!
*!*********************************************************************

FUNCTION erept(Buffer,ftopen)
*
* Modified on 06/19/90 for Clipper 5.0

* Modified on  Cinco de Mayo (May 5, 1990) to stop writing of duplicate
* messages to error file.  Saves last buffer sent in string ereptstr.
* if this string matches with the buffer sent, the function just returns.
* E. Mark Kothe
*
local handle,i

* to check for duplicate message
static ereptstr := '        '

* assign a errorfile name unless it exists, or was passed
if type("errfile") = 'C'
  ftopen=errfile
else
  if ftopen=nil

    * look thru call stack to end
    * last element is our starting procedure name
    i:=1
    while !empty(procname(i++))
    enddo

    * gotta subtract 2 to get to last valid name
    * example element 3 is valid, 4 will test empty, but
    * i++ will increment 1 further after finding blank
    ftopen =procname(i-2)+'.err'
  endif
endif

* if same, skip writing to file again!
if buffer == ereptstr
   return(.t.)
else
  * else save it for later!
  ereptstr=buffer
endif

handle = fopen(ftopen,2)
IF ferror() <> 0
   handle = fcreate(ftopen,0)
   IF ferror() <> 0
     yesno('DOS create error ('+ftopen+') in error module - DOS #'+ltrim(str(ferror())),3)
     fclose(handle)
     RETURN (.F.)
   ENDIF
else
  fseek(handle,0,2)  && get to EOF
  IF ferror() <> 0
     yesno('DOS seek error ('+ftopen+') in error module - DOS #'+ltrim(str(ferror())),3)
     fclose(handle)
     RETURN (.F.)
  ENDIF
ENDIF
fwrite(handle, DTOC(DATE())+' at '+TIME()+CHR(13)+CHR(10))
fwrite(handle,Buffer)
fwrite (handle, CHR(13)+CHR(10)+CHR(13)+CHR(10))
IF ferror() <> 0
     yesno('DOS write error ('+ftopen+') in error module - DOS #'+ltrim(str(ferror())),3)
   fclose(handle)
   RETURN (.F.)
ENDIF
fclose(handle)
IF ferror() <> 0
     yesno('DOS close error ('+ftopen+') in error module - DOS #'+ltrim(str(ferror())),3)
   RETURN (.F.)
ENDIF
return(.t.)
