
#include "error.ch"


****
*       SYSERROR.PRG
*

#define OUT(str)                BUILDBUF( str )
#define OUTNL(str)              BUILDBUF( Chr(13) + Chr(10) + str )


***
*       SysError()
*

proc ErrorSys()
        ErrorBlock( {|e| DefError(e)} )
return


***
*       DefError()
*
static func DefError(e)
local i
local ver_no:='v1.0'
i:=1
while !empty(procname(i++))
  if procname(i)=='(b)ERRORSYS'
    ?
    ? 'Error occured in Error Handler'
    ?
    close all
    commit
    quit
  endif
enddo
* clear buffer
buildbuf(.t.)

if ( e:genCode == EG_OPEN .and. NetErr() .and. e:canDefault )
  return (.f.)    /* ignore */
endif

/* put message to STDOUT */
OUTNL( "Error" )

if ( !Empty(e:subsystem()) )
  OUT( " " + e:subsystem() + "[" + LTrim(Str(e:subCode())) + "]" )
endif

if ( !Empty(e:description()) )
  OUT( "  " + e:description() )
endif

if ( !Empty(e:operation()) )
  OUT( ": " + e:operation() )
endif

if ( !Empty(e:filename()) )
  OUT( ": " + e:filename() )
endif

if ( e:canRetry)
  OUTNL( "Could have retried")
else
  OUTNL( "Could NOT retry")
endif

i:=e:params()
if (valtype(i) = 'A' )

  x:=len(i)
  if x=1
    OUTNL( "1 argument exists")
 else
    OUTNL( ALLTRIM(STR(X))+" arguments exist")
  endif

  for y:=1 to x
    OUTNL("Arg"+alltrim(str(y))+': Type = <'+;
    valtype(i[y])+'>   Value = <'+retstr(i[y])+'>')
  next y
else
  OUTNL('No arguments exist')
endif

i := 2
while (.t.)
  OUTNL( "Called from " + Trim(ProcName(i)) + ;
         "(" + Alltrim(Str(ProcLine(i))) + ")  " )
  i++

  if ( ProcName(i) == "" )
    OUTNL('Errors trapped by SysError - '+ver_no+', Copyright (c) E. Mark Kothe')
    buildbuf(.f.)
    ERRORLEVEL(1)
    QUIT
  endif
enddo

return (.f.)

function buildbuf(str_passed)
static buffer
if valtype(str_passed)=='L'
  if str_passed
    buffer=''
  else
    clear
    ? buffer
    erept(buffer)
  endif
else
  buffer+=str_passed
endif
return(.t.)

function retstr(oldstr)
*returns a string from whatever it was sent
DO CASE
  CASE valtype(oldstr)='C'
    RETURN(oldstr)
  CASE valtype(oldstr)='N'
    RETURN(STR(oldstr))
  CASE valtype(oldstr)='D'
    RETURN(DTOC(oldstr))
  CASE valtype(oldstr)='L'
    IF oldstr
      RETURN(".T.")
    ELSE
      RETURN(".F.")
    ENDIF
  CASE valtype(oldstr)='M'
    RETURN("(memo field)")
  CASE valtype(oldstr)='A'
    RETURN("(array)")
  OTHERWISE
   RETURN("Undefined")
ENDCASE

