*:*********************************************************************
*:
*:        Program: YESNO.PRG
*:
*:         System: Yes, No, No choice
*:         Author: E. Mark Kothe
*:      Copyright (c) 1989, E. Mark Kothe
*:  Last modified: 02/02/90     20:07
*:
*:  Procs & Fncts: YESNO()
*:
*:     Documented: 02/26/90 at 10:26                SNAP! version 3.11
*:*********************************************************************
* This function displays a string on the screen, and usually
* allows the operator a choice
* Returns - True if OK, False if not
* see attached for screen dump
* modified for Clipper 5.0 usage 06/19/90

FUNCTION yesno(strng,choice,r1,c1)

* Parameters are as follows
* String to display, Any length, will attempt to wrap.
* (optional) Prefered choice 1=ok, 2=Cancel,
* 3=no choice, just OK, 0=don't fix screen
* (optional) Row to start in
* (optional) Column to start in

local parts,X,fudge
local temp[25]
local c2,temp_scr
local lenstrng,r2
local rest

* center string, make at least 17 character long
IF LEN(strng) < 17
  strng=SPACE((17-LEN(strng))/2)+strng
  strng=pad(strng,17)
ENDIF

* check the column parameter, set for now.
IF pcount() < 4
  c1=0
ENDIF
IF c1 > 60
  c1=60
ENDIF

parts=1
lenstrng=0

* string too long, gotta split

IF LEN(Alltrim(strng)) > 76-c1
  strng=Alltrim(strng)

  * parse the elements to the nearest word into individual elements
  DO WHILE LEN(strng) > 76-c1 .AND. parts < 21
    temp[parts]=Alltrim(SUBSTR(strng,1,rat(' ',LEFT(strng,76-c1))))
    strng=Alltrim(SUBSTR(strng,LEN(temp[parts])+1))
    IF LEN(temp[parts]) > lenstrng
      lenstrng = LEN(temp[parts])
    ENDIF
    parts=parts+1
  ENDDO

  * if it did not fill the array, get the last part.
  IF parts <> 21
    * get last piece
    temp[parts]=strng
  ELSE
    * array full, probably truncated message, reset max element.
    parts=20
  ENDIF

  * we insist on minimum string length of 17 for buttons.
  IF lenstrng < 17
    lenstrng=17
  ENDIF
ELSE
  temp[1]=strng
  lenstrng=LEN(strng)
ENDIF


* set up our default rows, columns, and choice
DO CASE
CASE pcount() = 0
  RETURN 0
CASE pcount() = 1
  choice = 1
  r1=9
  c1=80-(lenstrng+4)
  IF c1>0
    c1=c1/2
  ELSE
    c1 = 0
  ENDIF
CASE pcount() = 2
  r1=9
  c1=80-(lenstrng+4)
  IF c1>0
    c1=c1/2
  ELSE
    c1 = 0
  ENDIF
CASE pcount() = 3
  c1=80-(lenstrng+4)
  IF c1>0
    c1=c1/2
  ELSE
    c1 = 0
  ENDIF
ENDCASE

* expand rows for # elements
r2=r1+5+(parts-1)

* push column to max string lengtn
c2=c1+lenstrng+2

* for 0 position on screen
IF c1>0
  c1=c1-1
ENDIF

* off screen, too low?
IF r2 > 24
  * see how far!
  X=r2-24
  * can we move it up?
  IF r1 >= X
    r1=r1-X
    r2=r2-X
  ELSE
    * just go as big as possible, and hope for the best!
    r1=0
    r2=24
  ENDIF
ENDIF
SAVE SCREEN TO temp_scr

* make a window
@r1, c1 CLEAR TO r2,c2
@r1, c1  TO r2, c2 DOUBLE

* say it
FOR X = 1 TO parts
  @r1+X,c1+2 SAY temp[x]
NEXT x

* this was added later, so gotta fudge the button position for
* single button entries

IF choice = 3 .or. choice = 0
  *single button
  fudge=(c2-c1-5)/2
ELSE
  fudge=(c2-c1-17)/2
ENDIF

IF fudge < 2
  fudge=2
ENDIF

* what do they want to do?
@r1+2+(parts-1),c1+fudge TO r1+4+(parts-1),c1+fudge+5
@r1+3+(parts-1),c1+fudge+1 PROMPT " Ok "
IF choice <> 3 .and. choice <> 0
  @r1+2+(parts-1),c1+fudge+7 TO r1+4+(parts-1),c1+fudge+16
  @r1+3+(parts-1),c1+fudge+8 PROMPT " Cancel "
ENDIF
rest:=(choice=0)
MENU TO choice
if ! rest
  RESTORE SCREEN FROM temp_scr
endif
* show their choice(T or F)
RETURN(choice=1)

*: EOF: YESNOX.PRG
